<template>
  <div class="createPost-container">
    <el-form ref="postForm" :model="postForm" :rules="rules" class="form-container">

      <sticky :class-name="'sub-navbar'">
        <el-button v-loading="loading" style="margin-left: 10px;" type="success" @click="submitForm">保存
        </el-button>
      </sticky>

      <div class="createPost-main-container">
        <el-row>
          <el-col :span="24">
            <el-form-item style="margin-bottom: 40px;" prop="name">
              <MDinput v-model="postForm.name" :maxlength="100" name="name" required>
                pick名称
              </MDinput>
            </el-form-item>
            <div class="postInfo-container">
              <el-row>
                <el-col :span="8">
                  <el-form-item label-width="45px" label="性别:" class="postInfo-container-item">
                    <el-select v-model="postForm.gender" :placeholder="'性别:'" clearable class="postInfo-container-item"
                               style="width: 120px">
                      <el-option v-for="item in GenderTypeOptions" :key="item.key" :label="item.display_name"
                                 :value="item.key"/>
                    </el-select>
                  </el-form-item>
                </el-col>
                <el-col :span="8">
                  <el-form-item label-width="60px" label="属性:" class="postInfo-container-item">
                    <el-select v-model="postForm.pick_type" :placeholder="'性别:'" clearable
                               class="postInfo-container-item" style="width:120px">
                      <el-option v-for="item in PickTypeOptions" :key="item.key" :label="item.display_name"
                                 :value="item.key"/>
                    </el-select>
                  </el-form-item>
                </el-col>
                <el-col :span="8">
                  <el-form-item style="margin-bottom: 40px;" label-width="45px" label="位置:" prop="position">
                    <el-input :rows="1" v-model="postForm.position" type="number" class="article-textarea"
                              style="width: 120px"
                              placeholder="请输入内容"/>
                  </el-form-item>
                </el-col>
              </el-row>
            </div>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="24">
            <div class="postInfo-container">
              <el-row>
                <el-col :span="8">
                  <el-form-item style="margin-bottom: 40px;" label-width="45px" label="pickid:" prop="id" v-if="isEdit">
                    <el-input :rows="1" v-model="postForm.id" type="number" class="article-textarea"
                              style="width: 120px" disabled/>
                  </el-form-item>
                </el-col>
                <el-col :span="8">
                  <el-form-item style="margin-bottom: 40px;" label-width="75px" label="pick用户:" prop="user_nums" v-if="isEdit">
                    <el-input :rows="1" v-model="postForm.user_nums" type="number" class="article-textarea"
                              style="width: 120px" disabled/>
                  </el-form-item>
                </el-col>
                <el-col :span="8">
                  <el-form-item style="margin-bottom: 40px;" label-width="85px" label="创建时间:" prop="create_time" v-if="isEdit">
                    <el-input :rows="1" v-model="postForm.create_time" type="text" class="article-textarea"
                              style="width: 170px" disabled/>
                  </el-form-item>
                </el-col>
              </el-row>
            </div>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="12">
            <el-form-item label-width="45px" label="地区:" class="postInfo-container-item">
              <el-select v-model="postForm.region" :remote-method="getRemoteRegionList" filterable remote multiple value-key="id"
                         placeholder="搜索地区" style="width: 100%">
                <el-option v-for="(item,index) in regionListOptions" :key="item+index" :label="item.name" :value="item.id"/>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">

            <el-form-item label-width="45px" label="小组:" class="postInfo-container-item">
              <el-select
                v-model="postForm.pick_group"
                :remote-method="getRemoteGroupList"
                multiple
                filterable
                remote
                reserve-keyword
                placeholder="搜索小组"
                style="width: 100%"
                :loading="loading"
                value-key="id"
              >
                <el-option v-for="(item, index) in groupListOptions" :key="item+index" :label="item.name" :value="item.id"/>
              </el-select>
            </el-form-item>
          </el-col>
        </el-row>
        <el-form-item style="margin-bottom: 40px;" label-width="45px" label="简介:" prop="desc">
          <el-input :rows="1" v-model="postForm.desc" type="textarea" class="article-textarea" autosize
                    placeholder="请输入内容"/>
          <span v-show="contentShortLength" class="word-counter">{{ contentShortLength }}字</span>
        </el-form-item>
        <el-form-item style="margin-bottom: 40px;" label-width="45px" label="下线:">
          <el-radio-group v-model="postForm.is_online">
            <el-radio :label="1">是</el-radio>
            <el-radio :label="0">否</el-radio>
          </el-radio-group>
        </el-form-item>
      </div>
    </el-form>

  </div>
</template>

<script>
  import MDinput from '@/components/MDinput'
  import Sticky from '@/components/Sticky' // 粘性header组件
  import {fetchPickDetail, CreatePick} from '@/api/pick'
  import {groupSearch, regionSearch} from '@/api/remoteSearch'
  import { isInArray, removeByvale} from "@/utils";

  function Assembledata(target, source) {
    var region_data = []
    for (var i=0;i<target.length;i++){
      if (isInArray(source, target[i]['name'])){
        region_data.push(target[i]['id'])
        removeByvale(source, target[i]['name']);
      }
    }
    region_data.push(...source)
    return region_data.join(',')
  }

  const defaultForm = {
    status: 'draft',
    name: '',
    desc: '',
    gender: '',
    region: [],
    pick_group: [],
    pick_type: '',
    position: '',
    is_online: 1,
  }

  export default {
    name: 'PickDetail',
    components: {MDinput, Sticky},
    props: {
      isEdit: {
        type: Boolean,
        default: false
      }
    },
    data() {
      const validateRequire = (rule, value, callback) => {
        if (value === '') {
          this.$message({
            message: rule.field + '为必传项',
            type: 'error'
          })
          callback(new Error(rule.field + '为必传项'))
        } else {
          callback()
        }
      }
      return {
        postForm: Object.assign({}, defaultForm),
        loading: false,
        regionListOptions: [],
        groupListOptions: [],
        GenderTypeOptions: [
          {'key': 2, 'display_name': '全部'},
          {'key': 0, 'display_name': '男'},
          {'key': 1, 'display_name': '女'},
        ],
        PickTypeOptions: [
          {'key': 1, 'display_name': '明星打榜'},
          {'key': 0, 'display_name': '用戶打榜'},
        ],
        rules: {
          name: [{validator: validateRequire, trigger: 'blur'}],
          desc: [{validator: validateRequire, trigger: 'blur'}],
          position: [{validator: validateRequire, trigger: 'blur'}],
        },
        tempRoute: {},
        temparray:{
          'region':[],
          'pick_group': [],
        }
      }
    },
    computed: {
      contentShortLength() {
        return this.postForm.desc.length
      }
    },
    created() {
      if (this.isEdit) {
        const id = this.$route.params && this.$route.params.id
        this.fetchData(id)
      } else {
        this.postForm = Object.assign({}, defaultForm)
      }

      this.tempRoute = Object.assign({}, this.$route)
    },
    methods: {
      fetchData(id) {
        fetchPickDetail(id).then(response => {
          // select 回填数据处理，后期再进行优化
          let rep = response.data.data.data;
          let pick_temp = []
          let region_temp = []
          for (let i=0;i<rep.pick_group.length;i++){
            pick_temp.push(rep.pick_group[i]['name']);
            this.temparray['pick_group'].push(rep.pick_group[i])
          }
          for (let i=0;i<rep.region.length;i++){
            region_temp.push(rep.region[i]['name']);
            this.temparray['region'].push(rep.region[i])
          }
          rep.region = region_temp
          rep.pick_group = pick_temp
          this.postForm = rep
        }).catch(err => {
          console.log(err)
        })
      },
      submitForm() {
        this.$refs.postForm.validate(valid => {
          if (valid) {
            this.loading = true;
            if (this.isEdit){
              this.postForm.region = Assembledata(this.temparray['region'], this.postForm.region);
              this.postForm.pick_group = Assembledata(this.temparray['pick_group'], this.postForm.pick_group);
            }else{
              this.postForm.region = this.postForm.region.join(',')
              this.postForm.region = this.postForm.region.join(',')
              this.postForm.pick_group = this.postForm.pick_group.join(',')
            }
            CreatePick(this.postForm).then(response => {
              this.$notify({
                title: '成功',
                message: response.data.data.message,
                type: 'success',
                duration: 2000
              })
              setTimeout(() => {
                this.$router.push('/pick/list')
              }, 1000)

            }).catch(err => {
              this.$notify({
                title: '失败',
                message: '操作失败',
                type: 'danger',
                duration: 2000
              })
            });


            this.postForm.status = 'published'
            this.loading = false
          } else {
            console.log('error submit!!')
            return false
          }
        })
      },
      getRemoteRegionList(query) {
        regionSearch(query).then(response => {
          if (!response.data.data.data) return
          this.regionListOptions = response.data.data.data
        })
      },
      getRemoteGroupList(query) {
        groupSearch(query).then(response => {
          if (!response.data.data.data) return
          this.groupListOptions = response.data.data.data
        })
      },
    }
  }
</script>

<style rel="stylesheet/scss" lang="scss" scoped>
  @import "src/styles/mixin.scss";

  .createPost-container {
    position: relative;
    .createPost-main-container {
      padding: 40px 45px 20px 50px;
      .postInfo-container {
        position: relative;
        @include clearfix;
        margin-bottom: 10px;
        .postInfo-container-item {
          float: left;
        }
      }
      .editor-container {
        min-height: 500px;
        margin: 0 0 30px;
        .editor-upload-btn-container {
          text-align: right;
          margin-right: 10px;
          .editor-upload-btn {
            display: inline-block;
          }
        }
      }
    }
    .word-counter {
      width: 40px;
      position: absolute;
      right: -10px;
      top: 0px;
    }
  }
</style>
